# Leap

Leap is a CLI to make working on projects inside a service oriented architecture easier.

## Dependencies

Leap is built upon Ruby 2.1.2.

While not a strict dependency, leap has not been tested on Linux or Windows. Don&rsquo;t expect the latter to work.

## Installation

To install leap and take advantage of its full command, you&rsquo;ll want to install it globally.

`sudo gem install leap-cli`

## Adding leap to a project

Leap uses convention through configuration. What that means is individual teams enforce their conventions through configuration in leap.

To do this, in each project create a `.leap` directory, inside of which you&rsquo;ll create a `config` file. This is ultimately a YAML file.

#### Example `config` file

```YAML
dependencies:
  - postgresql
  - redis

remotes:
  - origin:
    - git@github.com:generalassembly/turbo-octo-happiness.git
```

#### Adding leap start

The start script is just a shell script that starts your server. This could be as simple as:

```shell
rails s
```

Or as complex as you like. This simply gives a clear way for any dev new to a project start the server without having to ask, &ldquo;Is this a foreman project or do I use 'rails s' or some other way?&rdquo;

## Using leap

Leap is now part of your CLI. Using it is simple!

`$ leap`

## Contributing to leap

We&rsquo;d love to have all contributions that are sent our way that match the mission of the project. To that end, opening an issue before submitting a pull request is the best way to kick off the discussion as to whether your vision and our vision matches.

